#pragma once

//#include "resource.h"
//#include "../shared/devinfo.h"

class CSyncMutex
{
	HANDLE hMutex;
public:
	CSyncMutex()
	{
		hMutex=CreateMutex(NULL,FALSE,_T("DescriptorPageMutex"));
		WaitForSingleObject(hMutex,INFINITE);
	}

	~CSyncMutex()
	{
		ReleaseMutex(hMutex);
		CloseHandle(hMutex);
	}
};

class CUsbDevice
{
//	HANDLE hHub;
	DWORD connection;

	USB_NODE_CONNECTION_INFORMATION_EX *pnode;
	DWORD NodeSize;
	CString HubLink;
	DEVINST DevInst;
	CString DeviceLink;
	IDevice *pDevice;	// it is not recommended to store a reference for the IDevice pointer
//	CAtlArray<CString,CStringElementTraits<CString> > HidLinks;
	bool Composite;

public:
	CUsbDevice() : NodeSize(0), Composite(false)
	{
		pnode=NULL;
		pDevice=NULL;
	}

	~CUsbDevice()
	{
		delete []pnode;
	}

	CUsbDevice &operator =(const CUsbDevice &u)
	{
		if (pnode)
			delete []pnode;
		connection=u.connection;
		NodeSize=u.NodeSize;
		HubLink=u.HubLink;
		DevInst=u.DevInst;
		DeviceLink=u.DeviceLink;
		pDevice=u.pDevice;
		Composite=u.Composite;

		if (NodeSize)
		{
			pnode=(USB_NODE_CONNECTION_INFORMATION_EX *) new BYTE[NodeSize];
			memcpy(pnode,u.pnode,NodeSize);
		}
		return *this;
	}

/*	void AddHidLink(LPCTSTR HidLink) throw()
	{
		HidLinks.Add(HidLink);

		CAtlFile file;
		if (SUCCEEDED(file.Create(HidLink,0,FILE_SHARE_READ | FILE_SHARE_WRITE,OPEN_EXISTING)))
		{
			BYTE Buffer[1000]={0};
			Buffer[0]=1;
//			BOOL res=HidD_GetPhysicalDescriptor(file,Buffer,1000);
			BOOL res=HidD_GetFeature(file,Buffer,1000);
			int j=0;
		}

	}
//*/
	void Init(IDevice *pDevice);
	void Init(LPCTSTR DeviceKey);
	bool IsComposite() const throw() { return Composite; }

	CString GetStringDescriptor(UCHAR id) throw();
	USB_CONFIGURATION_DESCRIPTOR *GetConfigDescriptor();
	void *GetHIDDescriptor(HID_DESCRIPTOR *phid,int interfacenumber,int descnumber);
	static void FreeConfigDescriptor(USB_CONFIGURATION_DESCRIPTOR *ptr) throw()
	{
		USB_DESCRIPTOR_REQUEST *p=((USB_DESCRIPTOR_REQUEST *) ptr)-1;
		delete [](BYTE *) p;
	}

	static void FreeHIDDescriptor(void *ptr) throw()
	{
		USB_DESCRIPTOR_REQUEST *p=((USB_DESCRIPTOR_REQUEST *) ptr)-1;
		delete [](BYTE *) p;
	}

	static int GetBCDMajor(USHORT code)
	{
		return code/256;
	}

	static int GetBCDMinor(USHORT code)
	{
		code-=(code/256)*256;
		return (code/16)*10+(code-(code/16)*16);
	}

	DEVINST GetDevInst() const throw() { return DevInst; }

	USB_NODE_CONNECTION_INFORMATION_EX *GetNode() { return pnode; }

	operator bool() const { return DeviceLink!=_T("USBNext"); }
};
