#pragma once

//#include "device.h"

class CUsbDeviceConfigPage : 
	public CDialogImpl<CUsbDeviceConfigPage>,
	public CDialogResize<CUsbDeviceConfigPage>
{
	typedef CDialogImpl<CUsbDeviceConfigPage> baseClass;
	typedef CDialogResize<CUsbDeviceConfigPage> baseResize;
	
	CComPtr<IDockableSite> pDockableSite;
//	bool destroyed;
	CFlickerFreeTreeViewCtrlEx tree;
	CToolTipCtrl tooltip;
//	HWND hWndToolbar;

//	CImageList imlist;
	SP_CLASSIMAGELIST_DATA scid;

	UINT EditCopyNameId,EditRestartDeviceId,EditDevicePropertiesId;

	CTreeItem Add(CTreeItem root,DEVINST dev);

public:

	CUsbDeviceConfigPage(IDockableSite *pDockableSite_) :  pDockableSite(pDockableSite_)
	{}

	~CUsbDeviceConfigPage()
	{
//		if (!destroyed)
//			DestroyWindow();
		SetupDiDestroyClassImageList(&scid);
	}

	void Toggle() throw()
	{
		pDockableSite->ToggleClient(m_hWnd);
	}

	void Show(BOOL bShow=TRUE) throw()
	{
		pDockableSite->ShowClient(m_hWnd,bShow);
	}

	enum
	{
		IDD=IDD_USBINFO,
	};

	virtual void OnFinalMessage(HWND hWnd)
	{
		delete this;//destroyed=true;
	}

	void SetDevice(CUsbDevice &device);
	void OnContextMenu(HWND hWnd,CPoint &pt);

	void OnDestroy()
	{
		SetMsgHandled(FALSE);
//		::DestroyWindow(hWndToolbar);
	}
//
	BOOL OnInitDialog(HWND,LPARAM);
	void CopyString(const CString &string)
	{
		if (OpenClipboard())
		{
			EmptyClipboard();

			const DWORD Size=(string.GetLength()+1)*sizeof(TCHAR);
			HANDLE hObj=GlobalAlloc(GMEM_MOVEABLE,Size);
			memcpy(GlobalLock(hObj),(LPCTSTR) string,Size);
			GlobalUnlock(hObj);
			SetClipboardData(CF_UNICODETEXT,hObj);
			CloseClipboard();
		}
	}

	void OnCopyName(UINT,int,HWND)
	{
		CTreeItem item=tree.GetSelectedItem();
		CString name;
		item.GetText(name);
		
		CopyString(name);
	}

	void OnProperties(UINT,int,HWND);
	void OnRestart(UINT,int,HWND);
	LRESULT OnDoubleClick(NMHDR *pnmhdr)
	{
		CTreeItem item=tree.GetSelectedItem();
		if (item)
			OnProperties(0,0,0);
		return NULL;
	}

	LRESULT OnSelChange(NMHDR *pnmhdr)
	{
		NMTREEVIEW *p=(NMTREEVIEW *) pnmhdr;
		CComQIPtr<ICommandSite> pCommandSite(pDockableSite);
		pCommandSite->EnableGroup(ACTION(COMF_USBDEPDEVS),p->itemNew.hItem!=NULL);
		return NULL;
	}

BEGIN_MSG_MAP_EX(CUsbDeviceConfigPage)
	MSG_WM_INITDIALOG(OnInitDialog)
	MSG_WM_CONTEXTMENU(OnContextMenu)
	MSG_WM_DESTROY(OnDestroy)

	COMMAND_ID_HANDLER_EX(EditCopyNameId,OnCopyName)
	COMMAND_ID_HANDLER_EX(EditRestartDeviceId,OnRestart)
	COMMAND_ID_HANDLER_EX(EditDevicePropertiesId,OnProperties)

	NOTIFY_CODE_HANDLER_EX(NM_DBLCLK,OnDoubleClick)
	NOTIFY_CODE_HANDLER_EX(TVN_SELCHANGED,OnSelChange)

	CHAIN_MSG_MAP(baseResize)
ALT_MSG_MAP(1)
	COMMAND_ID_HANDLER_EX(EditCopyNameId,OnCopyName)
	COMMAND_ID_HANDLER_EX(EditRestartDeviceId,OnRestart)
	COMMAND_ID_HANDLER_EX(EditDevicePropertiesId,OnProperties)
END_MSG_MAP()

BEGIN_DLGRESIZE_MAP(CUsbDeviceConfigPage)
	DLGRESIZE_CONTROL(IDC_TREE1,DLSZ_SIZE_X | DLSZ_SIZE_Y)
END_DLGRESIZE_MAP()
};
