#include "stdafx.h"
#include "Preprocessor.h"

BOOL Preprocessor::Preprocess(const CString& strFile,const CString& strFileOut)
{
	CAtlArray<CString>* m_include_dirs = NULL;

	// The following preprocesses a given input file.
	// Open the file and read it into a string variable
	std::ifstream instream(strFile);
	std::ofstream outstream(strFileOut);

	if(!instream)
	{
		ATLASSERT(0);
		return FALSE;
	}

	if(!outstream)
	{
		// removed for clarity
		//return FALSE;
	}

	std::string input(
		std::istreambuf_iterator<char>(instream.rdbuf()),
		std::istreambuf_iterator<char>()
	);

	advanced_preprocessing_hooks hooks;
	hooks.m_graph = NULL;
	context_type ctx(input.begin(), input.end(), CW2A(strFile), hooks);
	
	std::string strVersionMacro;
	CStringA str; 
	str.Format("_SVC_VER=%d",0x201);
	
	ctx.add_macro_definition(std::string(str),true);
	
	if(m_include_dirs)
	{
		for(size_t i=0; i<m_include_dirs->GetCount(); ++i)
		{
			CStringA str(m_include_dirs->GetAt(i));
			ctx.add_include_path(str);
		}
	}

	// Get the preprocessor iterators and use them to generate 
	// the token sequence.
	context_type::iterator_type first = ctx.begin();
	context_type::iterator_type last = ctx.end();

	// The input stream is being preprocessed
	STRING_MAP string_map;
	UINT nPosition = 0;

	int nIteration = 0;
	int nPrevPosInFile = 0;

	while (first!=last) 
	{
		nIteration++;

		boost::wave::cpplexer::lex_token<file_pos> token = *first;
		
		// removed for clarity
		//outstream << token.get_value();

		file_pos pos = token.get_position();
		const BOOST_WAVE_STRINGTYPE& strFilePos = pos.get_file();

		std::string  strNormalString = strFilePos.c_str();
		ATL::CString string_curr(strNormalString.c_str());

		// filter only needed tokens (optimization)
		// generate the file positions mapping
		boost::wave::token_id tok_id = (boost::wave::token_id)token;

		++first;

		UINT size_token = (UINT)token.get_value().size();

		nPosition+=size_token;

		//somehow WAVE returns only one position for 0x0a 0x0d
		BOOST_WAVE_STRINGTYPE strTst = token.get_value();
		const char* pBuff	= strTst.c_str();
		if(pBuff[0]==0x0a)
			nPosition++;

		//nPrevPosInFile = pt.pos;
	}
	return TRUE;
}