#pragma once

typedef CAtlMap<CString,CString,CStringElementTraitsI<CString> >		GRAPH_MAP;
typedef GRAPH_MAP::CPair												GRAPH_PAIR;

typedef CAtlMap<CString,CString,CStringElementTraitsI<CString> >		DEFINES_MAP;
typedef GRAPH_MAP::CPair												DEFINES_PAIR;

/*
* Sample implementation - actually not used here
*/
class advanced_preprocessing_hooks
	:   public boost::wave::context_policies::default_preprocessing_hooks
{
public:
	advanced_preprocessing_hooks(){}

	
	template <typename ContextT, typename ExceptionT>
	void throw_exception(ContextT const& ctx, ExceptionT const& exc)
	{
		if(exc.get_errorcode()!=boost::wave::preprocess_exception::last_line_not_terminated)
			boost::throw_exception(exc);
	}

	template <typename ContextT>
	void opened_include_file(ContextT const& ctx, std::string const& relname,std::string const& absname, bool is_system_include)
	{
		CString strFirst(absname.c_str());
		CString strSecond(ctx.get_current_filename().c_str());
		
		strFirst.Replace('/','\\');
		strSecond.Replace('/','\\');

		if(m_graph)
			m_graph->SetAt(strFirst,strSecond);
	}
public:
	GRAPH_MAP* m_graph;
};

struct PositionTuple
{
	UINT  preprocessed_pos;
	UINT  pos;
	BYTE  file_index;
};

/*
* Just an copy from my project
*/
struct Preprocessor
{
public:
	typedef CAtlArray<PositionTuple>	POSITIONS_ARRAY;

	typedef boost::wave::cpplexer::lex_iterator<boost::wave::cpplexer::lex_token<> >							lex_iterator_type;
	
	typedef boost::wave::context<std::string::iterator, 
								lex_iterator_type,
								boost::wave::iteration_context_policies::load_file_to_string,
								advanced_preprocessing_hooks>													context_type;
	//*/


	typedef boost::wave::util::file_position<BOOST_WAVE_STRINGTYPE>												file_pos;

	typedef CAtlArray<CString>			STRING_ARRAY;
	typedef std::map<std::string,bool>	STRING_MAP;
	typedef STRING_MAP::const_iterator  STRING_MAP_ITERATOR;

public:
	BOOL Preprocess(const CString& strFile,const CString& strFileOut);

};
