#include "stdafx.h"
#include "preprocessor.h"

// MSVS10 Beta only
//#include "ppl.h"
//using namespace Concurrency;

struct FileDesc
{
	CString strFile;
	CString strFileOut;
};


DWORD WINAPI ThreadProc(LPVOID lpParam)
{
	FileDesc* file = (FileDesc*) lpParam;

	Preprocessor prep;
	prep.Preprocess(file->strFile,file->strFileOut);
	return 0;
}

int _tmain(int argc, _TCHAR* argv[])
{
	FileDesc files[] = 
	{
		{_T("C:\\test\\Samples\\test1.h"),_T("%temp%\\test1_prep")},
		{_T("C:\\test\\Samples\\test2.h"),_T("%temp%\\test2_prep")},
		{_T("C:\\test\\Samples\\test3.h"),_T("%temp%\\test3_prep")},
		{_T("C:\\test\\Samples\\test4.h"),_T("%temp%\\test4_prep")},
	};	

	/*
	// PPL 
	parallel_for(size_t(0),_countof(files),
		[&files](int i)
		{
			Preprocessor prep;
			prep.Preprocess(files[i].strFile,files[i].strFileOut);
		}
	);*/

	// direct CreateThread
	for(int i=0; i<_countof(files); ++i)
	{
		FileDesc* fd = new FileDesc;
		fd->strFile = files[i].strFile;
		fd->strFileOut = files[i].strFileOut;

		DWORD dwThreadId = 0;
		HANDLE hThread = CreateThread(NULL,0,ThreadProc,(void*)fd,0,&dwThreadId);
	}
	Sleep(10000);
	
	/*
	// this DOES work - no multithreading!
	for(int i = 0; i<_countof(files); ++i)
	{
		Preprocessor prep;
		prep.Preprocess(files[i].strFile,files[i].strFileOut);
	}*/
	return 0;
}

